package com.ekexiu.project.platform.organization;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@DAO
public interface OrgDao {

    @UpdateWith
    @From(Organization.class)
    int setlevel(Connection con, String id, @Set Integer level) throws SQLException;

    @SelectList
    @OrderBy("ORDER BY LEVEL ASC NULLS LAST")
    List<Organization> queryList(Connection con) throws SQLException;

    @SelectOne
    @Nullable
    Organization queryOne(Connection con, String id) throws SQLException;
    
    @DeleteWith
    @From(Organization.class)
    int delete(Connection con,String id)throws SQLException;
    
    @Insert
    int insert(Connection con,Organization org)throws SQLException;
}
