package com.ekexiu.project.platform.organization;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.DateUtil;
import org.jfw.util.exception.JfwBaseException;
import org.jfw.util.reflect.TypeReference;

import com.ekexiu.project.platform.professor.Professor;
import com.ekexiu.project.util.HttpService;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * Created by TT on 2018/11/22.
 */
@Path("/org")
public class OrgService {

	private String syncUrl = "http://www.ekexiu.com/ajax/platform/ids/buttedOrgs?pid=";
	private String infoUrl = "http://www.ekexiu.com/ajax/org/";
    @Autowrie
    private OrgDao orgDao;

    public OrgDao getOrgDao() {
        return orgDao;
    }

    public void setOrgDao(OrgDao orgDao) {
        this.orgDao = orgDao;
    }

    public String getSyncUrl() {
		return syncUrl;
	}

	public void setSyncUrl(String syncUrl) {
		this.syncUrl = syncUrl;
	}

	public String getInfoUrl() {
		return infoUrl;
	}

	public void setInfoUrl(String infoUrl) {
		this.infoUrl = infoUrl;
	}

	@Path("/setlevel")
    @Post
    public void setLevel(@JdbcConn(true) Connection con, String id, @Nullable Integer level) throws SQLException {
        orgDao.setlevel(con, id, level);
    }

    @Path("/list")
    @Get
    public List<Organization> querList(@JdbcConn Connection con) throws SQLException {
        return orgDao.queryList(con);
    }

    @Path("/qo")
    @Get
    public Organization queryOne(@JdbcConn Connection con, String id) throws SQLException {
        return orgDao.queryOne(con, id);
    }
    
	@Get
    @Path("/sync")
   synchronized public void sync(@JdbcConn(true) Connection con,String pid)throws SQLException, JfwBaseException, IOException{
    	 List<Organization> existsList = this.orgDao.queryList(con);
    	 List<Organization> insertList = new LinkedList<Organization>();
    	 
    	 List<Map<String,String>> buttedProfessores = HttpService.get(this.syncUrl+pid, new TypeReference<List<Map<String,String>>>() {
		} .getType());
    	 
    	 if(buttedProfessores.size()>0){
    		 for(Map<String,String> map:buttedProfessores){
    			 String uid = map.get("uid");
    			 if(uid!= null){
    				 Organization p = null;
    				for(Organization pe:existsList){
    					if(uid.equals(pe.getId())){
    						p = pe;
    					}
    				}
    				if(p == null){
	    				 p = new Organization();
	    				 p.setId(uid);
	    				 p.setAssTime(map.get("createTime"));
	    				 insertList.add(p);
    				}else{
    					existsList.remove(p);    					
    				}
    			 }
    		 }
    		 
    		 for(Organization p:insertList){
    			 Map<String,Object> map = HttpService.get(this.infoUrl+p.getId(), new TypeReference<Map<String,Object>>() {
    				} .getType());
    			 p.setShareId(-1);
    			 if(map!=null){
    				 Object tmp = map.get("shareId");
    				 if(tmp!= null && tmp instanceof Double){
    					 p.setShareId(((Double)tmp).longValue());
    					 if(p.getAssTime()==null){
    						 p.setAssTime(DateUtil.formatDateTime(System.currentTimeMillis()));
    					 }
    					 orgDao.insert(con, p);
    				 }
    			 }
    		 }
    	 }
    	 for(Organization p:existsList){
			 this.orgDao.delete(con, p.getId());
		 }
    }
}
