package com.ekexiu.project.platform.professor;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.DateUtil;
import org.jfw.util.exception.JfwBaseException;
import org.jfw.util.reflect.TypeReference;

import com.ekexiu.project.util.HttpService;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * Created by TT on 2018/11/20.
 */
@Path("/professor")
public class ProfessorService {

	private String syncUrl = "http://www.ekexiu.com/ajax/platform/ids/buttedProfessors?pid=";
	private String infoUrl = "http://www.ekexiu.com/ajax/professor/baseInfo/";

	@Autowrie
	private ProfessorDao professorDao;

	public String getInfoUrl() {
		return infoUrl;
	}

	public void setInfoUrl(String infoUrl) {
		this.infoUrl = infoUrl;
	}

	public String getSyncUrl() {
		return syncUrl;
	}

	public void setSyncUrl(String syncUrl) {
		this.syncUrl = syncUrl;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	@Path("/setlevel")
	@Post
	public void setLevel(@JdbcConn(true) Connection con, String id, @Nullable Integer level) throws SQLException {
		professorDao.setlevel(con, id, level);
	}

	@Path("/list")
	@Get
	public List<Professor> queryList(@JdbcConn Connection con) throws SQLException {
		return professorDao.queryList(con);
	}

	@Path("/qo")
	@Get
	public Professor queryOne(@JdbcConn Connection con, String id) throws SQLException {
		return professorDao.queryOne(con, id);
	}

	@Get
    @Path("/sync")
   synchronized public void sync(@JdbcConn(true) Connection con,String pid)throws SQLException, JfwBaseException, IOException{
    	 List<Professor> existsList = this.professorDao.queryList(con);
    	 List<Professor> insertList = new LinkedList<Professor>();
    	 
    	 List<Map<String,String>> buttedProfessores = HttpService.get(this.syncUrl+pid, new TypeReference<List<Map<String,String>>>() {
		} .getType());
    	 
    	 if(buttedProfessores.size()>0){
    		 for(Map<String,String> map:buttedProfessores){
    			 String uid = map.get("uid");
    			 if(uid!= null){
    				Professor p = null;
    				for(Professor pe:existsList){
    					if(uid.equals(pe.getId())){
    						p = pe;
    					}
    				}
    				if(p == null){
	    				 p = new Professor();
	    				 p.setId(uid);
	    				 p.setAssTime(map.get("createTime"));
	    				 insertList.add(p);
    				}else{
    					existsList.remove(p);    					
    				}
    			 }
    		 }
    		 
    		 for(Professor p:insertList){
    			 Map<String,Object> map = HttpService.get(this.infoUrl+p.getId(), new TypeReference<Map<String,Object>>() {
    				} .getType());
    			 p.setShareId(-1);
    			 if(map!=null){
    				 Object tmp = map.get("shareId");
    				 if(tmp!= null && tmp instanceof Double){
    					 p.setShareId(((Double)tmp).longValue());
    					 if(p.getAssTime()==null){
    						 p.setAssTime(DateUtil.formatDateTime(System.currentTimeMillis()));
    					 }
    					 professorDao.insert(con, p);
    				 }
    			 }
    		 }
    	 }
    	 for(Professor p:existsList){
			 this.professorDao.delete(con, p.getId());
		 }
    }
	
	
//	public static void main(String[] args) throws Exception{
//		 Map<String,Object> map = HttpService.get("http://www.ekexiu.com/ajax/professor/baseInfo/FA08E12933D64D76999512DDDF3958F9", new TypeReference<Map<String,Object>>() {
//			} .getType());
//
//		 if(map!=null){
//			 Object tmp = map.get("shareId");
//			 if(tmp!= null){
//				 System.out.println(((Double)tmp).longValue());
//			 }
//		 }
//		
//	}

}
